*+
*+
*+    Source Module => J:\FTPSITE\INCOMING\TEMP\AJBROW.PRG
*+
*+    Functions: Function ajbrow()
*+               Static Function NowBrowse()
*+               Static Function maketb()
*+               Static Function Aj_Left()
*+               Static Function Aj_Right()
*+               Static Function Aj_CtrlLeft()
*+               Static Function Aj_CtrlRight()
*+               Static Function Aj_CtrlHome()
*+               Static Function Aj_CtrlEnd()
*+
*+       Tables: dbusearea( .T.,, cDBF, "TestDBF", .T., .F. )
*+
*+    Reformatted by Click! 1.13 on Jan-10-1998 at  1:22 am
*+
*+

/*
Program File Name : AJBROW.PRG
Written By        : Andi Jahja
Written On        : 21 October 1997
Purpose           : To Solve Clipper "Error" In Browsing Data Base Of Many
                    Columns
Notes             : This is just a demo on how we could cure the "Tbrowse Limit
                    Exceeded". Please feel free to enhance :)
Email             : andijahj@link.net.id
WWW               : http://www.geocities.com/andijahja/index.html
*/

#include "inkey.ch"

static oCurCols
static num_of_flds
static nColumnBuff  // This Is The Key, We Will Only Display Tbrowse In DeskTop
                    // Of This Number Of Columns

*+
*+
*+    Function ajbrow()
*+
*+
*+
function ajbrow()

local cScreen := savescreen( 00, 00, maxrow(), maxcol() )
local cDBF    := "AJTEST.DBF"
local N
local M
local aStruct := {}
local Tb

// Define Colum Buffer
nColumnBuff := 10   // Try Other Value To Suit The Best Performance

// Cleaning DeskTop
scroll()
dispbox( 11, 14, 13, 65 )
setpos( 12, 15 )
dispout( Padc( "Preparing Test Files ...", 50 ) )

// Creating DBF of 1024 Fields -- WOW!
for N := 1 to 1024
   setpos( 12, 15 )
   dispout( Padc( "Creating " + ltrim( str( N ) ) + " Field ...", 50 ) )
   aadd( aStruct, { "Field" + ltrim( str( N ) ), "C", 10, 0 } )
next
dbcreate( cDBF, aStruct )

// Open File
dbusearea( .T.,, cDBF, "TestDBF", .T., .F. )

// Filling In Data Base, Just 100 Recs
for N := 1 to 100
   setpos( 12, 15 )
   dispout( Padc( "Adding " + ltrim( str( N ) ) + " Records ...", 50 ) )
   TestDBF->( dbappend() )
   for M := 1 to TestDBF->( fcount() )
      TestDBF->( fieldput( M, repl( ltrim( str( N ) ), 10 ) ) )
   next
next

// Static Vars Used In This Module
num_of_flds := TestDBF->( fcount() )
oCurCols    := array( TestDBF->( fcount() ) )

// Now Watch, We Browse DBF with 1024 Fields
TestDBF->( dbgotop() )
NowBrowse( Tb := MakeTb( aStruct, "TestDBF" ) )

// Finished
restscreen( 00, 00, maxrow(), maxcol(), cScreen )

return nil

*+
*+
*+    Static Function NowBrowse()
*+
*+    Called from ( ajbrow.prg   )   1 - function ajbrow()
*+
*+
*+
static function NowBrowse( tb )

local nKey
local lBrowsing := .T.

scroll()
while lBrowsing
   Tb:forcestable()
   nKey := inkey()
   do case
   case nKey == K_ESC
      lBrowsing := .F.

   case nKey == K_DOWN
      tb:Down()

   case nKey == K_UP
      tb:Up()

   case nKey == K_PGDN
      tb:PageDown()

   case nKey == K_PGUP
      tb:PageUp()

   case nKey == K_RIGHT
      AJ_Right( tb )

   case nKey == K_LEFT
      AJ_Left( tb )

   case nKey == K_CTRL_RIGHT
      AJ_CtrlRight( tb )

   case nKey == K_CTRL_LEFT
      AJ_CtrlLeft( tb )

   case nKey == K_CTRL_HOME
      AJ_CtrlHome( tb )

   case nKey == K_CTRL_END
      AJ_CtrlEnd( tb )

   endcase
enddo

return NIL

*+
*+
*+    Static Function maketb()
*+
*+    Called from ( ajbrow.prg   )   1 - function ajbrow()
*+
*+
*+
static function maketb( aStruct, cSelect )

local nIter
local tb      := TBrowseDB()
local oColumn

for nIter := 1 to len( aStruct )
   oColumn := TBColumnNew( aStruct[ nIter ] [ 1 ], fieldwblock( aStruct[ nIter ] [ 1 ], select( cSelect ) ) )
   if nIter <= nColumnBuff
      tb:addColumn( oColumn )
   endif
   oCurCols[ nIter ] := oColumn
next
tb:ntop    := 1
tb:nleft   := 1
tb:nbottom := 23
tb:nright  := 77
tb:headsep := ""
tb:colsep  := "  "
tb:footsep := ""
tb:freeze  := 0
tb:rowPos  := 1
tb:colPos  := 1
tb:cargo   := { 1, min( nColumnBuff, len( aStruct ) - 1 ) }

return tb

*+
*+
*+    Static Function Aj_Left()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_Left( tb )

local iLeftVis
local iRightVis
local iRightOfs
local iLeftOfs
local iCurOfs
local iCols
local iFreeze
local i

if tb:colPos == tb:leftVisible .and. ;
           tb:leftVisible == tb:freeze + 1 .and. ;
           tb:cargo[ 1 ] > tb:freeze + 1

   // next TBrowse columns
   iLeftVis  := tb:leftVisible
   iRightVis := tb:rightVisible
   iFreeze   := tb:freeze
   iCols     := tb:colCount
   iRightOfs := tb:cargo[ 2 ] - iCols + iRightVis - 1
   iCurOfs   := tb:cargo[ 1 ]

   // remove old columns to the right
   for i := iCols to iFreeze + 1 step - 1
      tb:delColumn( i )
   next

   // instead of insert, add new columns from left to right
   iLeftOfs := max( iFreeze + 1, iRightOfs - nColumnBuff + iFreeze + 1 )
   for i := 1 to ( iRightOfs - iLeftOfs + 1 )
      tb:addColumn( oCurCols[ iLeftOfs + i - 1 ] )
   next

   // store new borders in cargo
   tb:cargo[ 1 ] := iLeftOfs
   tb:cargo[ 2 ] := iRightOfs

   // reposition browse columns - align from right to left
   tb:panEnd()
   tb:forcestable()

   // move cursor to column left of previous offset
   i := iRightOfs + 1
   while -- i >= iCurOfs
      tb:left()
   end
   tb:invalidate()
else
   tb:left()
endif

return NIL

*+
*+
*+    Static Function Aj_Right()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_Right( tb )

local iLeftVis
local iRightVis
local iLeftOfs
local iCurOfs
local iRestCols
local iFreeze
local i
local iPos
local iNew

if tb:colPos == tb:rightVisible .and. ;
           tb:colPos == tb:cargo[ 2 ] - tb:cargo[ 1 ] + tb:freeze + 1 .and. ;
           tb:cargo[ 2 ] < num_of_flds

   // next TBrowse columns
   iRightVis := tb:rightVisible
   iLeftVis  := min( tb:leftVisible, iRightVis )            // bug in TBrowse
   iFreeze   := tb:freeze
   iLeftOfs  := tb:cargo[ 1 ] + iLeftVis - iFreeze
   iPos      := iLeftOfs + iRightVis - iLeftVis + iFreeze

   // remove old columns to the left
   for i := iLeftVis to iFreeze + 1 step - 1
      tb:delColumn( i )
   next
   iRestCols := tb:colCount

   // add new columns to the right
   iCurOfs := iLeftOfs + iRestCols - iFreeze - 1
   i       := 0
   iNew    := max( 1, nColumnBuff - iRestCols - iFreeze )
   do while ( ++ i <= iNew ) .and. ( iCurOfs < num_of_flds )
      tb:addColumn( oCurCols[ ++ iCurOfs ] )
   enddo

   // store new borders in cargo
   tb:cargo[ 1 ] := iLeftOfs
   tb:cargo[ 2 ] := iCurOfs

   // reposition browse columns - align from left to right
   tb:panHome()
   tb:forcestable()
   i := iLeftOfs - 1
   while ++ i < iPos
      tb:right()
   end
   tb:invalidate()
else
   tb:right()
endif

return NIL

*+
*+
*+    Static Function Aj_CtrlLeft()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_CtrlLeft( tb )

local iLeftVis
local iRightVis
local iRightOfs
local iLeftOfs
local iCurOfs
local iCols
local iFreeze
local i

if tb:leftVisible == tb:freeze + 1 .and. ;
           tb:cargo[ 1 ] > tb:freeze + 1

   // next TBrowse columns
   iLeftVis  := tb:leftVisible
   iRightVis := tb:rightVisible
   iFreeze   := tb:freeze
   iCols     := tb:colCount
   iRightOfs := tb:cargo[ 2 ] - iCols + iRightVis - 1
   iCurOfs   := tb:cargo[ 1 ] + tb:colPos - 1

   // remove old columns to the right
   for i := iCols to iFreeze + 1 step - 1
      tb:delColumn( i )
   next

   // instead of insert, add new columns from left to right
   iLeftOfs := max( iFreeze + 1, iRightOfs - nColumnBuff + iFreeze + 1 )
   for i := 1 to ( iRightOfs - iLeftOfs + 1 )
      tb:addColumn( oCurCols[ iLeftOfs + i - 1 ] )
   next

   // store new borders in cargo
   tb:cargo[ 1 ] := iLeftOfs
   tb:cargo[ 2 ] := iRightOfs

   // reposition browse columns - align from right to left
   tb:panEnd()
   tb:forcestable()

   // move cursor to column left of previous offset
   i := iRightOfs + 1
   while -- i >= iCurOfs
      tb:left()
   end
   tb:invalidate()
else
   tb:panLeft()
endif

return NIL

*+
*+
*+    Static Function Aj_CtrlRight()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_CtrlRight( tb )

local iLeftVis
local iRightVis
local iLeftOfs
local iCurOfs
local iRestCols
local iFreeze
local iPos
local i

if tb:rightVisible == tb:cargo[ 2 ] - tb:cargo[ 1 ] + tb:freeze + 1 .and. ;
           tb:cargo[ 2 ] < num_of_flds

   // next TBrowse columns
   iLeftVis  := tb:leftVisible
   iRightVis := tb:rightVisible
   iFreeze   := tb:freeze
   iLeftOfs  := tb:cargo[ 1 ] + iLeftVis - iFreeze
   iPos      := tb:colPos - iLeftVis + 1

   // remove old columns to the left
   for i := iLeftVis to iFreeze + 1 step - 1
      tb:delColumn( i )
   next
   iRestCols := tb:colCount

   // add new columns to the right
   iCurOfs := iLeftOfs + iRestCols - iFreeze - 1
   i       := 0
   do while ( ++ i <= nColumnBuff - iRestCols - iFreeze ) .and. ;
                 ( iCurOfs < num_of_flds )
      tb:addColumn( oCurCols[ ++ iCurOfs ] )
   enddo

   // store new borders in cargo
   tb:cargo[ 1 ] := iLeftOfs
   tb:cargo[ 2 ] := iCurOfs

   // reposition browse columns - align from left to right
   tb:panHome()
   tb:forcestable()
   tb:colPos := iPos
   tb:invalidate()
else
   tb:panRight()
endif

return NIL

*+
*+
*+    Static Function Aj_CtrlHome()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_CtrlHome( tb )

local iRightOfs
local iCols
local iFreeze
local i

if tb:cargo[ 1 ] > tb:freeze + 1

   // next TBrowse columns
   iFreeze   := tb:freeze
   iCols     := tb:colCount
   iRightOfs := min( nColumnBuff, num_of_flds )

   // remove old columns to the right
   for i := iCols to iFreeze + 1 step - 1
      tb:delColumn( i )
   next

   // add new columns from left
   i := iFreeze
   do while ( ++ i <= iRightOfs )
      tb:addColumn( oCurCols[ i ] )
   enddo

   // store new borders in cargo
   tb:cargo[ 1 ] := iFreeze + 1
   tb:cargo[ 2 ] := iRightOfs

endif
tb:panHome()

return NIL

*+
*+
*+    Static Function Aj_CtrlEnd()
*+
*+    Called from ( ajbrow.prg   )   1 - static function nowbrowse()
*+
*+
*+
static function Aj_CtrlEnd( tb )

local iLeftOfs
local iRightOfs
local iCols
local iFreeze
local i

if tb:cargo[ 2 ] < num_of_flds

   // next TBrowse columns
   iFreeze   := tb:freeze
   iCols     := tb:colCount
   iRightOfs := num_of_flds
   iLeftOfs  := max( iRightOfs - nColumnBuff + iFreeze, iFreeze ) + 1

   // remove old columns to the right
   for i := iCols to iFreeze + 1 step - 1
      tb:delColumn( i )
   next

   // add new columns from left
   i := iLeftOfs - 1
   do while ( ++ i <= iRightOfs )
      tb:addColumn( oCurCols[ i ] )
   enddo

   // store new borders in cargo
   tb:cargo[ 1 ] := iLeftOfs
   tb:cargo[ 2 ] := iRightOfs

endif
tb:panEnd()

return NIL

*+ EOF: AJBROW.PRG
